! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program checkimage

  use dal
  use errorhandling

  implicit none

  ! Handles
  type(DataSetT) :: srcset, bkgset
  type(ArrayT) :: srcimg, bkgimg

  ! Pointers, etc.
  integer (kind=int32), pointer, dimension(:,:) :: src, bkg

  ! Fetch source image
  srcset=dataSet("srcimage.fits",read)
  srcimg=array(srcset,"PRIMARY",read)
  src=>int32Array2Data(srcimg)

  ! Fetch background image
  bkgset=dataSet("bkgimage.fits",read)
  bkgimg=array(bkgset,"PRIMARY",read)
  bkg=>int32Array2Data(bkgimg)

  !
  if(sum(src)==0)call error('err',"source region rejects all events")
  if(sum(bkg)==0)call error('err',"background region rejects all events")
  if(sum(src*bkg)>0)call error('err',"source & background regions overlap")
  
  !
  call release(srcimg)
  call release(srcset)
  call release(bkgimg)
  call release(bkgset)

end program checkimage
